
import java.lang.reflect.Method;

import javassist.*;

public class Example1 {

	public static void main (String[] args) throws Exception {
		ClassPool pool = ClassPool.getDefault();

		// the class name is 'Eval'
		CtClass evalClass = pool.makeClass("Eval");

		// and a method that evaluates a formula for a given parameter
		evalClass.addMethod(
			CtNewMethod.make("public double eval (double x) { return ("+args[0]+") ; }", evalClass));

		// get a java.lang.Class object from Javassist's CtClass object
		Class clazz = evalClass.toClass();

		// instantiate it
		Object obj = clazz.newInstance();

		// get a handle to the method we added earlier
		Class[] formalParams = new Class[] { double.class };
		Method meth = clazz.getDeclaredMethod("eval", formalParams);

		// and finally call the method with the fixed parameter 17
		Object[] actualParams = new Object[] { new Double(17) };
		double result = ((Double) meth.invoke(obj, actualParams)).doubleValue();
		System.out.println(result);

		// now we can use the Method object to call the method multiple times
		actualParams = new Object[] { new Double(-43) };
		result = ((Double) meth.invoke(obj, actualParams)).doubleValue();
		System.out.println(result);
	}
}

