
import javassist.*;

public class Example4 {

	public static void main (String[] args) throws Exception {
		ClassPool pool = ClassPool.getDefault();

		// get the superclass from the pool
		CtClass exprClass = pool.get("Expr");

		// the class name is 'Eval'
		CtClass evalClass = pool.makeClass("Eval"+System.currentTimeMillis());
			// Since we don't really care about the class name, we'll append the
			// current milliseconds as a minimal guard against multi-threading problems

		// extend the 'Expr" class, so we can access all the Math functions
		evalClass.setSuperclass(exprClass);

		// the interface implemented by the new class
		evalClass.setInterfaces(
			new CtClass[] { pool.makeClass("Evaluator") });

		// add the eval method to the class
		evalClass.addMethod(
			CtNewMethod.make("public double eval (double x) { return ("+args[0]+") ; }", evalClass));

		// get a java.lang.Class object from Javassist's CtClass object
		Class clazz = evalClass.toClass();

		// instantiate it and cast it to Evaluator
		Evaluator obj  = (Evaluator) clazz.newInstance();

		// and finally call the method
		double result = obj.eval(Double.parseDouble(args[1]));
		System.out.println(result);
	}
}

